2010-12-02 01:48:02 +03:00
# Hey Emacs, this is a -*- shell-script -*- !!!
2007-06-01 14:54:26 +04:00
# utility functions for ctdb event scripts
2010-12-15 02:08:16 +03:00
[ -z "$CTDB_VARDIR" ] && {
2011-10-13 22:26:05 +04:00
if [ -d "/var/lib/ctdb" ] ; then
export CTDB_VARDIR="/var/lib/ctdb"
else
export CTDB_VARDIR="/var/ctdb"
fi
2010-12-15 02:08:16 +03:00
}
2011-06-07 09:57:29 +04:00
[ -z "$CTDB_ETCDIR" ] && {
export CTDB_ETCDIR="/etc"
}
2010-12-15 02:08:16 +03:00
2007-06-03 16:07:07 +04:00
#######################################
# pull in a system config file, if any
2010-08-31 11:40:40 +04:00
_loadconfig() {
2009-11-13 10:28:25 +03:00
2009-11-20 08:45:36 +03:00
if [ -z "$1" ] ; then
2009-11-19 07:00:17 +03:00
foo="${service_config:-${service_name}}"
if [ -n "$foo" ] ; then
loadconfig "$foo"
2013-05-14 08:56:26 +04:00
return
2009-11-19 07:00:17 +03:00
fi
2013-05-14 08:56:26 +04:00
fi
if [ "$1" != "ctdb" ] ; then
2010-01-22 09:19:12 +03:00
loadconfig "ctdb"
2009-11-13 10:28:25 +03:00
fi
2013-05-14 08:56:26 +04:00
if [ -z "$1" ] ; then
return
fi
2011-06-07 09:57:29 +04:00
if [ -f $CTDB_ETCDIR/sysconfig/$1 ]; then
. $CTDB_ETCDIR/sysconfig/$1
elif [ -f $CTDB_ETCDIR/default/$1 ]; then
. $CTDB_ETCDIR/default/$1
2009-11-20 08:45:36 +03:00
elif [ -f $CTDB_BASE/sysconfig/$1 ]; then
. $CTDB_BASE/sysconfig/$1
2007-06-03 16:07:07 +04:00
fi
2013-09-23 10:22:36 +04:00
if [ "$1" = "ctdb" ] ; then
_config="${CTDB_BASE}/ctdbd.conf"
if [ -r "$_config" ] ; then
. "$_config"
fi
fi
2007-06-03 16:07:07 +04:00
}
2010-08-31 11:40:40 +04:00
loadconfig () {
_loadconfig "$@"
}
2011-08-17 03:00:46 +04:00
##############################################################
2013-04-17 07:12:32 +04:00
# CTDB_SCRIPT_DEBUGLEVEL can be overwritten by setting it in a
# configuration file.
2011-08-17 03:44:11 +04:00
debug ()
{
2013-04-17 07:12:32 +04:00
if [ ${CTDB_SCRIPT_DEBUGLEVEL:-2} -ge 4 ] ; then
2011-08-17 03:44:11 +04:00
# If there are arguments then echo them. Otherwise expect to
# use stdin, which allows us to pass lots of debug using a
# here document.
if [ -n "$1" ] ; then
echo "DEBUG: $*"
elif ! tty -s ; then
sed -e 's@^@DEBUG: @'
fi
fi
}
2012-03-07 09:09:56 +04:00
die ()
{
_msg="$1"
_rc="${2:-1}"
echo "$_msg"
exit $_rc
}
2012-10-16 10:04:48 +04:00
# Log given message or stdin to either syslog or a CTDB log file
# $1 is the tag passed to logger if syslog is in use.
script_log ()
2012-09-03 09:37:01 +04:00
{
2012-10-16 10:04:48 +04:00
_tag="$1" ; shift
2014-08-11 11:07:41 +04:00
case "$CTDB_LOGGING" in
file:*|"")
if [ -n "$CTDB_LOGGING" ] ; then
_file="${CTDB_LOGGING#file:}"
2012-10-16 10:04:48 +04:00
else
2014-08-11 11:07:41 +04:00
_file="/var/log/log.ctdb"
2012-10-16 10:04:48 +04:00
fi
2014-08-11 11:07:41 +04:00
{
if [ -n "$*" ] ; then
echo "$*"
else
cat
fi
} >>"$_file"
;;
*)
2014-08-08 14:59:21 +04:00
# Handle all syslog:* variants here too. There's no tool to do
# the lossy things, so just use logger.
2014-08-11 11:07:41 +04:00
logger -t "ctdbd: ${_tag}" $*
;;
esac
2012-10-16 10:04:48 +04:00
}
# When things are run in the background in an eventscript then logging
# output might get lost. This is the "solution". :-)
background_with_logging ()
{
2012-09-03 09:37:01 +04:00
(
"$@" 2>&1 </dev/null |
2013-04-22 07:48:06 +04:00
script_log "${script_name}&"
2012-09-03 09:37:01 +04:00
)&
return 0
}
2011-08-23 10:32:34 +04:00
##############################################################
# check number of args for different events
ctdb_check_args ()
{
case "$1" in
takeip|releaseip)
if [ $# != 4 ]; then
echo "ERROR: must supply interface, IP and maskbits"
exit 1
fi
;;
updateip)
if [ $# != 5 ]; then
echo "ERROR: must supply old interface, new interface, IP and maskbits"
exit 1
fi
;;
esac
}
2009-01-16 15:26:57 +03:00
##############################################################
# determine on what type of system (init style) we are running
2013-10-18 06:24:03 +04:00
detect_init_style()
{
2009-01-16 15:26:57 +03:00
# only do detection if not already set:
2013-10-18 06:24:03 +04:00
[ -z "$CTDB_INIT_STYLE" ] || return
2009-01-16 15:26:57 +03:00
if [ -x /sbin/startproc ]; then
CTDB_INIT_STYLE="suse"
elif [ -x /sbin/start-stop-daemon ]; then
2009-09-15 13:33:35 +04:00
CTDB_INIT_STYLE="debian"
2009-01-16 15:26:57 +03:00
else
CTDB_INIT_STYLE="redhat"
fi
}
2007-06-01 14:54:26 +04:00
2007-06-02 12:51:05 +04:00
######################################################
# simulate /sbin/service on platforms that don't have it
2011-06-07 09:57:29 +04:00
# _service() makes it easier to hook the service() function for
# testing.
_service ()
{
2009-11-13 10:28:25 +03:00
_service_name="$1"
_op="$2"
2009-01-16 15:31:02 +03:00
# do nothing, when no service was specified
2009-11-20 08:45:36 +03:00
[ -z "$_service_name" ] && return
2009-01-16 15:31:02 +03:00
2007-06-02 12:51:05 +04:00
if [ -x /sbin/service ]; then
2011-06-07 09:57:29 +04:00
$_nice /sbin/service "$_service_name" "$_op"
2014-12-01 04:21:16 +03:00
elif [ -x /usr/sbin/service ]; then
$_nice /usr/sbin/service "$_service_name" "$_op"
2011-06-07 09:57:29 +04:00
elif [ -x $CTDB_ETCDIR/init.d/$_service_name ]; then
$_nice $CTDB_ETCDIR/init.d/$_service_name "$_op"
elif [ -x $CTDB_ETCDIR/rc.d/init.d/$_service_name ]; then
$_nice $CTDB_ETCDIR/rc.d/init.d/$_service_name "$_op"
2007-06-02 12:51:05 +04:00
fi
}
2011-06-07 09:57:29 +04:00
service()
{
_nice=""
_service "$@"
}
2008-02-13 00:20:20 +03:00
######################################################
# simulate /sbin/service (niced) on platforms that don't have it
2011-06-07 09:57:29 +04:00
nice_service()
{
_nice="nice"
_service "$@"
2008-02-13 00:20:20 +03:00
}
2007-06-17 05:57:42 +04:00
2011-06-28 08:54:33 +04:00
######################################################
# wrapper around /proc/ settings to allow them to be hooked
# for testing
# 1st arg is relative path under /proc/, 2nd arg is value to set
set_proc ()
{
echo "$2" >"/proc/$1"
}
######################################################
# wrapper around getting file contents from /proc/ to allow
# this to be hooked for testing
# 1st arg is relative path under /proc/
get_proc ()
{
cat "/proc/$1"
}
2014-11-14 05:31:03 +03:00
######################################################
# Print up to $_max kernel stack traces for processes named $_program
program_stack_traces ()
{
_prog="$1"
_max="${2:-1}"
_count=1
for _pid in $(pidof "$_prog") ; do
[ $_count -le $_max ] || break
# Do this first to avoid racing with process exit
_stack=$(get_proc "${_pid}/stack" 2>/dev/null)
if [ -n "$_stack" ] ; then
echo "Stack trace for ${_prog}[${_pid}]:"
echo "$_stack"
_count=$(($_count + 1))
fi
done
}
2010-12-17 08:25:04 +03:00
######################################################
# Check that an RPC service is healthy -
# this includes allowing a certain number of failures
# before marking the NFS service unhealthy.
#
# usage: nfs_check_rpc_service SERVICE_NAME [ triple ...]
#
# each triple is a set of 3 arguments: an operator, a
# fail count limit and an action string.
#
# For example:
#
# nfs_check_rpc_service "lockd" \
# -ge 15 "verbose restart unhealthy" \
# -eq 10 "restart:bs"
#
# says that if lockd is down for 15 iterations then do
# a verbose restart of lockd and mark the node unhealthy.
# Before this, after 10 iterations of failure, the
# service is restarted silently in the background.
# Order is important: the number of failures need to be
# specified in reverse order because processing stops
# after the first condition that is true.
######################################################
nfs_check_rpc_service ()
{
_prog_name="$1" ; shift
2013-04-23 00:27:02 +04:00
if _nfs_check_rpc_common "$_prog_name" ; then
return
fi
while [ -n "$3" ] ; do
2013-04-23 00:28:27 +04:00
if _nfs_check_rpc_action "$1" "$2" "$3" ; then
2013-04-23 00:27:02 +04:00
break
fi
shift 3
done
}
2013-04-23 00:42:54 +04:00
# The new way of doing things...
nfs_check_rpc_services ()
{
# Files must end with .check - avoids editor backups, RPM fu, ...
for _f in "${CTDB_BASE}/nfs-rpc-checks.d/"[0-9][0-9].*.check ; do
_t="${_f%.check}"
_prog_name="${_t##*/[0-9][0-9].}"
if _nfs_check_rpc_common "$_prog_name" ; then
# This RPC service is up, check next service...
continue
fi
# Check each line in the file in turn until one of the limit
# checks is hit...
while read _cmp _lim _rest ; do
# Skip comments
case "$_cmp" in
\#*) continue ;;
esac
if _nfs_check_rpc_action "$_cmp" "$_lim" "$_rest" ; then
# Limit was hit on this line, no further checking...
break
fi
done <"$_f"
done
}
2013-04-23 00:27:02 +04:00
_nfs_check_rpc_common ()
{
_prog_name="$1"
2013-04-22 23:54:12 +04:00
# Some platforms don't have separate programs for all services.
case "$_prog_name" in
statd)
which "rpc.${_prog_name}" >/dev/null 2>&1 || return 0
esac
2010-12-17 08:25:04 +03:00
case "$_prog_name" in
2013-04-23 06:30:33 +04:00
nfsd)
2010-12-17 08:25:04 +03:00
_rpc_prog=nfs
2013-04-23 00:14:43 +04:00
_version=3
2010-12-17 08:25:04 +03:00
;;
mountd)
2013-08-02 10:05:46 +04:00
_rpc_prog=mountd
_version=1
2010-12-17 08:25:04 +03:00
;;
rquotad)
2013-08-02 10:05:46 +04:00
_rpc_prog=rquotad
_version=1
2010-12-17 08:25:04 +03:00
;;
lockd)
_rpc_prog=nlockmgr
2013-04-23 00:14:43 +04:00
_version=4
2010-12-17 08:25:04 +03:00
;;
statd)
_rpc_prog=status
2013-08-02 10:05:46 +04:00
_version=1
2010-12-17 08:25:04 +03:00
;;
*)
echo "Internal error: unknown RPC program \"$_prog_name\"."
exit 1
esac
_service_name="nfs_${_prog_name}"
if ctdb_check_rpc "$_rpc_prog" $_version >/dev/null ; then
ctdb_counter_init "$_service_name"
return 0
fi
ctdb_counter_incr "$_service_name"
2013-04-23 00:27:02 +04:00
return 1
2010-12-17 08:25:04 +03:00
}
2013-04-23 00:28:27 +04:00
_nfs_check_rpc_action ()
2013-04-22 09:45:13 +04:00
{
_cmp="$1"
_limit="$2"
_actions="$3"
if ctdb_check_counter "quiet" "$_cmp" "$_limit" "$_service_name" ; then
return 1
fi
for _action in $_actions ; do
case "$_action" in
verbose)
echo "$ctdb_check_rpc_out"
;;
2013-08-02 10:05:46 +04:00
restart)
_nfs_restart_rpc_service "$_prog_name"
;;
restart:b)
_nfs_restart_rpc_service "$_prog_name" true
2013-04-22 09:45:13 +04:00
;;
unhealthy)
exit 1
;;
*)
echo "Internal error: unknown action \"$_action\"."
exit 1
esac
done
return 0
}
2013-08-02 10:05:46 +04:00
_nfs_restart_rpc_service ()
{
_prog_name="$1"
_background="${2:-false}"
if $_background ; then
_maybe_background="background_with_logging"
else
_maybe_background=""
fi
_p="rpc.${_prog_name}"
case "$_prog_name" in
nfsd)
echo "Trying to restart NFS service"
$_maybe_background startstop_nfs restart
;;
mountd)
echo "Trying to restart $_prog_name [${_p}]"
killall -q -9 "$_p"
2014-11-14 05:59:16 +03:00
nfs_dump_some_threads "$_p"
2013-08-02 10:05:46 +04:00
$_maybe_background $_p ${MOUNTD_PORT:+-p} $MOUNTD_PORT
;;
rquotad)
echo "Trying to restart $_prog_name [${_p}]"
killall -q -9 "$_p"
2014-11-14 05:59:16 +03:00
nfs_dump_some_threads "$_p"
2013-08-02 10:05:46 +04:00
$_maybe_background $_p ${RQUOTAD_PORT:+-p} $RQUOTAD_PORT
;;
lockd)
echo "Trying to restart lock manager service"
$_maybe_background startstop_nfslock restart
;;
statd)
echo "Trying to restart $_prog_name [${_p}]"
killall -q -9 "$_p"
2014-11-14 05:59:16 +03:00
nfs_dump_some_threads "$_p"
2013-08-02 10:05:46 +04:00
$_maybe_background $_p \
${STATD_HOSTNAME:+-n} $STATD_HOSTNAME \
${STATD_PORT:+-p} $STATD_PORT \
${STATD_OUTGOING_PORT:+-o} $STATD_OUTGOING_PORT
;;
*)
echo "Internal error: unknown RPC program \"$_prog_name\"."
exit 1
esac
}
2007-06-06 06:08:42 +04:00
######################################################
# check that a rpc server is registered with portmap
# and responding to requests
2010-12-17 08:25:04 +03:00
# usage: ctdb_check_rpc SERVICE_NAME VERSION
2007-06-06 06:08:42 +04:00
######################################################
2010-12-17 08:25:04 +03:00
ctdb_check_rpc ()
{
2009-11-20 08:45:36 +03:00
progname="$1"
2010-12-17 08:25:04 +03:00
version="$2"
2010-11-16 11:31:18 +03:00
2013-08-05 09:12:14 +04:00
_localhost="${CTDB_RPCINFO_LOCALHOST:-127.0.0.1}"
if ! ctdb_check_rpc_out=$(rpcinfo -u $_localhost $progname $version 2>&1) ; then
2010-11-16 11:31:18 +03:00
ctdb_check_rpc_out="ERROR: $progname failed RPC check:
$ctdb_check_rpc_out"
echo "$ctdb_check_rpc_out"
return 1
fi
2007-06-06 06:08:42 +04:00
}
2013-04-29 21:45:21 +04:00
######################################################
# Ensure $service_name is set
assert_service_name ()
{
[ -n "$service_name" ] || die "INTERNAL ERROR: \$service_name not set"
}
2007-06-06 06:08:42 +04:00
######################################################
# check a set of directories is available
2009-10-12 09:32:49 +04:00
# return 1 on a missing directory
2013-04-29 21:48:51 +04:00
# directories are read from stdin
2007-06-06 06:08:42 +04:00
######################################################
2013-04-29 21:48:51 +04:00
ctdb_check_directories_probe()
{
2009-11-20 08:45:36 +03:00
while IFS="" read d ; do
case "$d" in
*%*)
continue
;;
*)
2010-03-26 18:40:00 +03:00
[ -d "${d}/." ] || return 1
2009-11-20 08:45:36 +03:00
esac
done
2008-07-23 09:35:46 +04:00
}
######################################################
# check a set of directories is available
2013-04-29 21:48:51 +04:00
# directories are read from stdin
2008-07-23 09:35:46 +04:00
######################################################
2013-04-29 21:48:51 +04:00
ctdb_check_directories()
{
2009-11-20 08:45:36 +03:00
ctdb_check_directories_probe || {
2013-04-29 21:48:51 +04:00
echo "ERROR: $service_name directory \"$d\" not available"
2009-11-20 08:45:36 +03:00
exit 1
}
2007-06-06 06:08:42 +04:00
}
######################################################
# check a set of tcp ports
2009-11-20 08:45:36 +03:00
# usage: ctdb_check_tcp_ports <ports...>
2007-06-06 06:08:42 +04:00
######################################################
2011-08-05 10:39:57 +04:00
# This flag file is created when a service is initially started. It
# is deleted the first time TCP port checks for that service succeed.
# Until then ctdb_check_tcp_ports() prints a more subtle "error"
# message if a port check fails.
_ctdb_check_tcp_common ()
{
2013-04-29 21:45:21 +04:00
assert_service_name
2011-08-05 10:39:57 +04:00
_ctdb_service_started_file="$ctdb_fail_dir/$service_name.started"
}
ctdb_check_tcp_init ()
{
_ctdb_check_tcp_common
mkdir -p "${_ctdb_service_started_file%/*}" # dirname
touch "$_ctdb_service_started_file"
}
2013-10-17 08:23:35 +04:00
# Check whether something is listening on all of the given TCP ports
# using the "ctdb checktcpport" command.
2011-07-05 05:32:06 +04:00
ctdb_check_tcp_ports()
{
2011-08-17 06:12:20 +04:00
if [ -z "$1" ] ; then
echo "INTERNAL ERROR: ctdb_check_tcp_ports - no ports specified"
exit 1
fi
2013-10-17 08:23:35 +04:00
for _p ; do # process each function argument (port)
_cmd="ctdb checktcpport $_p"
_out=$($_cmd 2>&1)
_ret=$?
case "$_ret" in
2011-08-17 06:12:20 +04:00
0)
_ctdb_check_tcp_common
if [ ! -f "$_ctdb_service_started_file" ] ; then
echo "ERROR: $service_name tcp port $_p is not responding"
2013-10-17 08:23:35 +04:00
debug "\"ctdb checktcpport $_p\" was able to bind to port"
2011-08-17 06:12:20 +04:00
else
echo "INFO: $service_name tcp port $_p is not responding"
fi
2011-08-17 08:02:45 +04:00
return 1
;;
98)
# Couldn't bind, something already listening, next port...
continue
;;
*)
2013-10-17 08:23:35 +04:00
echo "ERROR: unexpected error running \"ctdb checktcpport\""
debug <<EOF
ctdb checktcpport (exited with $_ret) with output:
2011-08-17 08:02:45 +04:00
$_out"
2013-10-17 08:23:35 +04:00
EOF
return $_ret
2011-08-17 08:02:45 +04:00
esac
done
2013-10-17 08:23:35 +04:00
# All ports listening
_ctdb_check_tcp_common
rm -f "$_ctdb_service_started_file"
2011-08-17 08:02:45 +04:00
return 0
}
2009-05-19 02:47:19 +04:00
######################################################
# check a unix socket
# usage: ctdb_check_unix_socket SERVICE_NAME <socket_path>
######################################################
ctdb_check_unix_socket() {
2009-11-20 08:45:36 +03:00
socket_path="$1"
[ -z "$socket_path" ] && return
2009-05-19 02:47:19 +04:00
2009-11-20 08:45:36 +03:00
if ! netstat --unix -a -n | grep -q "^unix.*LISTEN.*${socket_path}$"; then
echo "ERROR: $service_name socket $socket_path not found"
return 1
2009-05-19 02:47:19 +04:00
fi
}
2007-06-17 06:05:29 +04:00
######################################################
# check a command returns zero status
2013-04-29 21:54:17 +04:00
# usage: ctdb_check_command <command>
2007-06-17 06:05:29 +04:00
######################################################
2013-04-29 21:54:17 +04:00
ctdb_check_command ()
{
_out=$("$@" 2>&1) || {
echo "ERROR: $* returned error"
echo "$_out" | debug
exit 1
}
2007-06-17 06:05:29 +04:00
}
2007-10-11 01:27:38 +04:00
################################################
# kill off any TCP connections with the given IP
################################################
2013-05-06 10:23:25 +04:00
kill_tcp_connections ()
{
_ip="$1"
2013-04-30 00:19:18 +04:00
_oneway=false
if [ "$2" = "oneway" ] ; then
_oneway=true
fi
2013-05-06 10:23:25 +04:00
get_tcp_connections_for_ip "$_ip" | {
_killcount=0
2013-07-25 07:40:43 +04:00
_connections=""
_nl="
"
while read _dst _src; do
_destport="${_dst##*:}"
2013-04-30 00:25:26 +04:00
__oneway=$_oneway
case $_destport in
# we only do one-way killtcp for CIFS
139|445) __oneway=true ;;
esac
2013-07-25 07:40:43 +04:00
echo "Killing TCP connection $_src $_dst"
_connections="${_connections}${_nl}${_src} ${_dst}"
2013-04-30 00:25:26 +04:00
if ! $__oneway ; then
2013-07-25 07:40:43 +04:00
_connections="${_connections}${_nl}${_dst} ${_src}"
2013-04-30 00:25:26 +04:00
fi
2008-08-20 03:47:00 +04:00
2013-05-06 10:23:25 +04:00
_killcount=$(($_killcount + 1))
2013-04-30 00:25:26 +04:00
done
2013-05-06 10:23:25 +04:00
if [ $_killcount -eq 0 ] ; then
return
fi
2013-04-30 05:39:46 +04:00
2013-07-25 07:40:43 +04:00
echo "$_connections" | ctdb killtcp || {
echo "Failed to send killtcp control"
return
}
2013-04-30 00:25:26 +04:00
_count=0
2013-04-30 05:39:46 +04:00
while : ; do
2013-08-06 06:42:13 +04:00
_remaining=$(get_tcp_connections_for_ip $_ip | wc -l)
if [ $_remaining -eq 0 ] ; then
2013-05-06 10:23:25 +04:00
echo "Killed $_killcount TCP connections to released IP $_ip"
2013-04-30 05:39:46 +04:00
return
fi
_count=$(($_count + 1))
if [ $_count -gt 3 ] ; then
2014-01-13 09:34:50 +04:00
echo "Timed out killing tcp connections for IP $_ip ($_remaining remaining)"
2013-04-30 05:39:46 +04:00
return
fi
2013-08-06 06:42:13 +04:00
echo "Waiting for $_remaining connections to be killed for IP $_ip"
2013-04-30 05:39:46 +04:00
sleep 1
2013-04-30 00:25:26 +04:00
done
}
2009-03-24 06:05:31 +03:00
}
##################################################################
# kill off the local end for any TCP connections with the given IP
##################################################################
2013-05-06 10:23:25 +04:00
kill_tcp_connections_local_only ()
2013-04-30 00:19:18 +04:00
{
kill_tcp_connections "$1" "oneway"
2007-10-11 01:27:38 +04:00
}
2009-12-18 11:43:20 +03:00
##################################################################
# tickle any TCP connections with the given IP
##################################################################
2013-05-06 10:23:25 +04:00
tickle_tcp_connections ()
{
_ip="$1"
2009-12-18 11:43:20 +03:00
2013-05-06 10:23:25 +04:00
get_tcp_connections_for_ip "$_ip" |
2013-04-30 00:25:26 +04:00
{
2013-04-30 00:31:30 +04:00
_failed=false
2013-04-30 00:25:26 +04:00
while read dest src; do
echo "Tickle TCP connection $src $dest"
2013-04-30 00:31:30 +04:00
ctdb tickle $src $dest >/dev/null 2>&1 || _failed=true
2013-04-30 00:25:26 +04:00
echo "Tickle TCP connection $dest $src"
2013-04-30 00:31:30 +04:00
ctdb tickle $dest $src >/dev/null 2>&1 || _failed=true
2013-04-30 00:25:26 +04:00
done
2013-04-30 00:31:30 +04:00
if $_failed ; then
2013-04-30 00:25:26 +04:00
echo "Failed to send tickle control"
2013-04-30 00:31:30 +04:00
fi
2009-12-18 11:43:20 +03:00
}
}
2013-04-30 00:25:26 +04:00
get_tcp_connections_for_ip ()
{
_ip="$1"
netstat -tn | awk -v ip=$_ip \
'index($1, "tcp") == 1 && \
(index($4, ip ":") == 1 || index($4, "::ffff:" ip ":") == 1) \
&& $6 == "ESTABLISHED" \
{print $4" "$5}'
}
2008-02-11 01:35:37 +03:00
########################################################
2012-05-16 11:24:21 +04:00
# start/stop the Ganesha nfs service
########################################################
startstop_ganesha()
{
2013-01-09 14:41:39 +04:00
_service_name="nfs-ganesha-$CTDB_CLUSTER_FILESYSTEM_TYPE"
2012-05-16 11:24:21 +04:00
case "$1" in
start)
service "$_service_name" start
;;
stop)
service "$_service_name" stop
;;
restart)
2014-11-14 08:39:07 +03:00
service "$_service_name" stop
nfs_dump_some_threads "rpc.statd"
service "$_service_name" start
2012-05-16 11:24:21 +04:00
;;
esac
}
########################################################
2008-02-11 01:35:37 +03:00
# start/stop the nfs service on different platforms
########################################################
startstop_nfs() {
PLATFORM="unknown"
2011-06-07 09:57:29 +04:00
[ -x $CTDB_ETCDIR/init.d/nfsserver ] && {
2008-02-11 01:35:37 +03:00
PLATFORM="sles"
}
2014-06-26 04:36:17 +04:00
[ -x $CTDB_ETCDIR/init.d/nfslock -o \
-r /usr/lib/systemd/system/nfs-lock.service ] && {
2008-02-11 01:35:37 +03:00
PLATFORM="rhel"
}
case $PLATFORM in
sles)
case $1 in
start)
service nfsserver start
;;
stop)
service nfsserver stop > /dev/null 2>&1
;;
2010-08-19 01:18:22 +04:00
restart)
2011-06-28 08:58:13 +04:00
set_proc "fs/nfsd/threads" 0
2011-01-11 09:06:48 +03:00
service nfsserver stop > /dev/null 2>&1
pkill -9 nfsd
2013-06-13 05:56:25 +04:00
nfs_dump_some_threads
2011-01-11 09:06:48 +03:00
service nfsserver start
2010-08-19 01:18:22 +04:00
;;
2008-02-11 01:35:37 +03:00
esac
;;
rhel)
case $1 in
start)
service nfslock start
service nfs start
;;
stop)
2011-01-14 01:31:05 +03:00
service nfs stop
service nfslock stop
2008-02-11 01:35:37 +03:00
;;
2010-08-19 01:18:22 +04:00
restart)
2011-06-28 08:58:13 +04:00
set_proc "fs/nfsd/threads" 0
2011-01-11 09:06:48 +03:00
service nfs stop > /dev/null 2>&1
service nfslock stop > /dev/null 2>&1
pkill -9 nfsd
2013-06-13 05:56:25 +04:00
nfs_dump_some_threads
2011-01-11 09:06:48 +03:00
service nfslock start
service nfs start
2010-08-19 01:18:22 +04:00
;;
2008-02-11 01:35:37 +03:00
esac
;;
*)
echo "Unknown platform. NFS is not supported with ctdb"
exit 1
;;
esac
}
2008-02-11 01:52:09 +03:00
2013-06-13 05:56:25 +04:00
# Dump up to the configured number of nfsd thread backtraces.
nfs_dump_some_threads ()
{
2014-11-14 05:48:16 +03:00
_prog="${1:-nfsd}"
2014-11-14 05:31:03 +03:00
_num="${CTDB_NFS_DUMP_STUCK_THREADS:-5}"
[ $_num -gt 0 ] || return 0
2013-06-13 05:56:25 +04:00
2014-11-14 05:48:16 +03:00
program_stack_traces "$_prog" $_num
2013-06-13 05:56:25 +04:00
}
2008-02-11 01:52:09 +03:00
########################################################
# start/stop the nfs lockmanager service on different platforms
########################################################
startstop_nfslock() {
PLATFORM="unknown"
2011-06-07 09:57:29 +04:00
[ -x $CTDB_ETCDIR/init.d/nfsserver ] && {
2008-02-11 01:52:09 +03:00
PLATFORM="sles"
}
2014-06-26 04:36:17 +04:00
[ -x $CTDB_ETCDIR/init.d/nfslock -o \
-r /usr/lib/systemd/system/nfs-lock.service ] && {
2008-02-11 01:52:09 +03:00
PLATFORM="rhel"
}
case $PLATFORM in
sles)
# for sles there is no service for lockmanager
# so we instead just shutdown/restart nfs
case $1 in
start)
service nfsserver start
;;
stop)
service nfsserver stop > /dev/null 2>&1
;;
2010-10-14 01:12:41 +04:00
restart)
2013-07-30 10:21:36 +04:00
service nfsserver stop > /dev/null 2>&1
2010-10-14 01:12:41 +04:00
service nfsserver start
;;
2008-02-11 01:52:09 +03:00
esac
;;
rhel)
case $1 in
start)
service nfslock start
;;
stop)
service nfslock stop > /dev/null 2>&1
;;
2010-10-14 01:12:41 +04:00
restart)
2013-07-30 10:21:36 +04:00
service nfslock stop > /dev/null 2>&1
2010-10-14 01:12:41 +04:00
service nfslock start
;;
2008-02-11 01:52:09 +03:00
esac
;;
*)
echo "Unknown platform. NFS locking is not supported with ctdb"
exit 1
;;
esac
}
2008-04-10 00:50:12 +04:00
2013-05-28 06:01:57 +04:00
# Periodically update the statd database
nfs_statd_update ()
{
_update_period="$1"
_statd_update_trigger="$service_state_dir/update-trigger"
[ -f "$_statd_update_trigger" ] || touch "$_statd_update_trigger"
_last_update=$(stat --printf="%Y" "$_statd_update_trigger")
_current_time=$(date +"%s")
if [ $(( $_current_time - $_last_update)) -ge $_update_period ] ; then
touch "$_statd_update_trigger"
$CTDB_BASE/statd-callout updatelocal &
$CTDB_BASE/statd-callout updateremote &
fi
}
2014-01-28 07:41:25 +04:00
########################################################
add_ip_to_iface ()
2010-01-20 13:10:48 +03:00
{
2012-03-07 09:18:12 +04:00
_iface=$1
_ip=$2
_maskbits=$3
2010-01-20 13:10:48 +03:00
2014-01-28 07:41:25 +04:00
# Ensure interface is up
ip link set "$_iface" up || \
die "Failed to bringup interface $_iface"
2010-01-20 13:10:48 +03:00
2014-11-20 13:58:31 +03:00
# Only need to define broadcast for IPv4
case "$ip" in
*:*) _bcast="" ;;
*) _bcast="brd +" ;;
esac
ip addr add "$_ip/$_maskbits" $_bcast dev "$_iface" || {
2014-03-14 06:14:18 +04:00
echo "Failed to add $_ip/$_maskbits on dev $_iface"
return 1
}
2014-11-21 09:33:21 +03:00
# Wait 5 seconds for IPv6 addresses to stop being tentative...
if [ -z "$_bcast" ] ; then
for _x in $(seq 1 10) ; do
ip addr show to "${_ip}/128" | grep -q "tentative" || break
sleep 0.5
done
# If the address was a duplicate then it won't be on the
# interface so flag an error.
_t=$(ip addr show to "${_ip}/128")
case "$_t" in
"")
echo "Failed to add $_ip/$_maskbits on dev $_iface"
return 1
;;
*tentative*|*dadfailed*)
echo "Failed to add $_ip/$_maskbits on dev $_iface"
ip addr del "$_ip/$_maskbits" dev "$_iface"
return 1
;;
esac
fi
2010-01-20 13:10:48 +03:00
}
delete_ip_from_iface()
{
2012-03-07 09:18:12 +04:00
_iface=$1
_ip=$2
_maskbits=$3
2014-01-28 07:41:25 +04:00
# This could be set globally for all interfaces but it is probably
# better to avoid surprises, so limit it the interfaces where CTDB
# has public IP addresses. There isn't anywhere else convenient
# to do this so just set it each time. This is much cheaper than
# remembering and re-adding secondaries.
set_proc "sys/net/ipv4/conf/${_iface}/promote_secondaries" 1
2012-03-07 09:18:12 +04:00
2014-03-14 06:14:18 +04:00
ip addr del "$_ip/$_maskbits" dev "$_iface" || {
echo "Failed to del $_ip on dev $_iface"
return 1
}
2010-02-12 11:48:01 +03:00
}
2014-12-19 06:19:32 +03:00
# If the given IP is hosted then print 2 items: maskbits and iface
2013-01-04 04:23:29 +04:00
ip_maskbits_iface ()
{
_addr="$1"
2014-11-21 06:37:54 +03:00
case "$_addr" in
*:*) _family="inet6" ; _bits=128 ;;
*) _family="inet" ; _bits=32 ;;
esac
ip addr show to "${_addr}/${_bits}" 2>/dev/null | \
awk -v family="${_family}" \
2014-12-19 06:19:32 +03:00
'NR == 1 { iface = $2; sub(":$", "", iface) } \
$1 ~ /inet/ { mask = $2; sub(".*/", "", mask); \
print mask, iface, family }'
2013-01-04 04:23:29 +04:00
}
drop_ip ()
{
_addr="${1%/*}" # Remove optional maskbits
set -- $(ip_maskbits_iface $_addr)
if [ -n "$1" ] ; then
_maskbits="$1"
_iface="$2"
2013-06-16 14:24:10 +04:00
echo "Removing public address $_addr/$_maskbits from device $_iface"
2013-06-18 08:53:17 +04:00
delete_ip_from_iface $_iface $_addr $_maskbits >/dev/null 2>&1
2013-01-04 04:23:29 +04:00
fi
}
drop_all_public_ips ()
{
while read _ip _x ; do
2013-06-16 14:24:10 +04:00
drop_ip "$_ip"
2013-01-03 08:07:07 +04:00
done <"${CTDB_PUBLIC_ADDRESSES:-/dev/null}"
}
2014-11-21 06:46:00 +03:00
flush_route_cache ()
{
set_proc sys/net/ipv4/route/flush 1
set_proc sys/net/ipv6/route/flush 1
}
2009-09-30 15:05:16 +04:00
########################################################
2013-08-02 09:18:47 +04:00
# Simple counters
2009-09-30 15:05:16 +04:00
_ctdb_counter_common () {
2013-04-30 09:31:27 +04:00
_service_name="${1:-${service_name:-${script_name}}}"
2010-12-15 02:48:00 +03:00
_counter_file="$ctdb_fail_dir/$_service_name"
2009-09-30 15:05:16 +04:00
mkdir -p "${_counter_file%/*}" # dirname
}
ctdb_counter_init () {
2010-12-16 02:11:33 +03:00
_ctdb_counter_common "$1"
2009-09-30 15:05:16 +04:00
2009-11-19 08:48:19 +03:00
>"$_counter_file"
2009-09-30 15:05:16 +04:00
}
ctdb_counter_incr () {
2010-12-16 02:11:33 +03:00
_ctdb_counter_common "$1"
2009-09-30 15:05:16 +04:00
# unary counting!
echo -n 1 >> "$_counter_file"
}
2010-12-17 08:10:56 +03:00
ctdb_check_counter () {
_msg="${1:-error}" # "error" - anything else is silent on fail
_op="${2:--ge}" # an integer operator supported by test
_limit="${3:-${service_fail_limit}}"
shift 3
_ctdb_counter_common "$1"
# unary counting!
_size=$(stat -c "%s" "$_counter_file" 2>/dev/null || echo 0)
2013-08-02 09:18:47 +04:00
_hit=false
if [ "$_op" != "%" ] ; then
if [ $_size $_op $_limit ] ; then
_hit=true
fi
else
if [ $(($_size $_op $_limit)) -eq 0 ] ; then
_hit=true
fi
fi
if $_hit ; then
2010-12-17 08:10:56 +03:00
if [ "$_msg" = "error" ] ; then
2013-08-08 10:02:44 +04:00
echo "ERROR: $_size consecutive failures for $_service_name, marking node unhealthy"
2010-12-17 08:10:56 +03:00
exit 1
else
return 1
fi
fi
}
2010-11-17 05:50:56 +03:00
2009-11-13 10:28:25 +03:00
########################################################
2013-12-18 10:08:55 +04:00
ctdb_status_dir="$CTDB_VARDIR/state/service_status"
ctdb_fail_dir="$CTDB_VARDIR/state/failcount"
2010-12-15 02:45:17 +03:00
2010-12-15 02:49:48 +03:00
ctdb_setup_service_state_dir ()
{
2013-12-18 10:08:55 +04:00
service_state_dir="$CTDB_VARDIR/state/service_state/${1:-${service_name}}"
2010-12-15 02:49:48 +03:00
mkdir -p "$service_state_dir" || {
echo "Error creating state dir \"$service_state_dir\""
exit 1
}
}
2010-12-15 02:45:17 +03:00
########################################################
# Managed status history, for auto-start/stop
2013-12-18 10:08:55 +04:00
ctdb_managed_dir="$CTDB_VARDIR/state/managed_history"
2010-12-15 02:45:17 +03:00
_ctdb_managed_common ()
{
2013-04-29 21:32:29 +04:00
_ctdb_managed_file="$ctdb_managed_dir/$service_name"
2010-12-15 02:45:17 +03:00
}
ctdb_service_managed ()
{
2013-04-29 21:32:29 +04:00
_ctdb_managed_common
2010-12-15 02:45:17 +03:00
mkdir -p "$ctdb_managed_dir"
touch "$_ctdb_managed_file"
}
ctdb_service_unmanaged ()
{
2013-04-29 21:32:29 +04:00
_ctdb_managed_common
2010-12-15 02:45:17 +03:00
rm -f "$_ctdb_managed_file"
}
is_ctdb_previously_managed_service ()
{
2013-04-29 21:32:29 +04:00
_ctdb_managed_common
2010-12-15 02:45:17 +03:00
[ -f "$_ctdb_managed_file" ]
}
########################################################
# Check and set status
2009-11-13 10:28:25 +03:00
2009-11-25 08:34:49 +03:00
log_status_cat ()
{
2010-03-10 12:39:31 +03:00
echo "node is \"$1\", \"${script_name}\" reports problem: $(cat $2)"
2009-11-25 08:34:49 +03:00
}
2009-11-13 10:28:25 +03:00
ctdb_checkstatus ()
{
2009-11-25 08:42:14 +03:00
if [ -r "$ctdb_status_dir/$script_name/unhealthy" ] ; then
log_status_cat "unhealthy" "$ctdb_status_dir/$script_name/unhealthy"
2009-11-13 10:28:25 +03:00
return 1
2009-11-25 08:42:14 +03:00
elif [ -r "$ctdb_status_dir/$script_name/banned" ] ; then
log_status_cat "banned" "$ctdb_status_dir/$script_name/banned"
2009-11-13 10:28:25 +03:00
return 2
else
return 0
fi
}
ctdb_setstatus ()
{
2009-11-25 08:42:14 +03:00
d="$ctdb_status_dir/$script_name"
2009-11-13 10:28:25 +03:00
case "$1" in
unhealthy|banned)
mkdir -p "$d"
cat "$2" >"$d/$1"
;;
*)
for i in "banned" "unhealthy" ; do
rm -f "$d/$i"
done
;;
esac
}
2010-12-15 11:19:21 +03:00
##################################################################
# Reconfigure a service on demand
_ctdb_service_reconfigure_common ()
{
2013-04-29 20:59:41 +04:00
_d="$ctdb_status_dir/${service_name}"
2010-12-15 11:19:21 +03:00
mkdir -p "$_d"
_ctdb_service_reconfigure_flag="$_d/reconfigure"
}
2009-11-13 10:28:25 +03:00
ctdb_service_needs_reconfigure ()
{
2013-04-29 20:59:41 +04:00
_ctdb_service_reconfigure_common
2010-12-15 11:19:21 +03:00
[ -e "$_ctdb_service_reconfigure_flag" ]
2009-09-30 15:05:16 +04:00
}
2009-11-13 10:28:25 +03:00
ctdb_service_set_reconfigure ()
{
2013-04-29 20:59:41 +04:00
_ctdb_service_reconfigure_common
2010-12-15 11:19:21 +03:00
>"$_ctdb_service_reconfigure_flag"
2009-11-13 10:28:25 +03:00
}
ctdb_service_unset_reconfigure ()
{
2013-04-29 20:59:41 +04:00
_ctdb_service_reconfigure_common
2010-12-15 11:19:21 +03:00
rm -f "$_ctdb_service_reconfigure_flag"
2009-11-13 10:28:25 +03:00
}
ctdb_service_reconfigure ()
{
2013-04-29 20:59:41 +04:00
echo "Reconfiguring service \"${service_name}\"..."
ctdb_service_unset_reconfigure
service_reconfigure || return $?
ctdb_counter_init
2010-12-15 11:19:21 +03:00
}
2012-12-04 08:00:44 +04:00
# Default service_reconfigure() function does nothing.
2010-12-15 11:19:21 +03:00
service_reconfigure ()
{
2012-12-04 08:00:44 +04:00
:
2010-12-15 11:19:21 +03:00
}
2013-12-18 06:51:22 +04:00
ctdb_reconfigure_take_lock ()
2011-05-16 08:23:28 +04:00
{
2013-04-29 20:59:41 +04:00
_ctdb_service_reconfigure_common
2011-05-16 08:23:28 +04:00
_lock="${_d}/reconfigure_lock"
2013-04-22 00:52:49 +04:00
mkdir -p "${_lock%/*}" # dirname
2011-05-16 08:23:28 +04:00
touch "$_lock"
(
flock 0
# This is overkill but will work if we need to extend this to
# allow certain events to run multiple times in parallel
# (e.g. takeip) and write multiple PIDs to the file.
read _locker_event
if [ -n "$_locker_event" ] ; then
while read _pid ; do
if [ -n "$_pid" -a "$_pid" != $$ ] && \
kill -0 "$_pid" 2>/dev/null ; then
exit 1
fi
done
fi
printf "%s\n%s\n" "$event_name" $$ >"$_lock"
exit 0
) <"$_lock"
}
2013-12-18 06:51:22 +04:00
ctdb_reconfigure_release_lock ()
{
_ctdb_service_reconfigure_common
_lock="${_d}/reconfigure_lock"
rm -f "$_lock"
}
2011-05-16 08:23:28 +04:00
ctdb_replay_monitor_status ()
{
echo "Replaying previous status for this script due to reconfigure..."
2014-11-20 06:32:46 +03:00
# Leading separator ('|') is missing in some versions...
_out=$(ctdb scriptstatus -X | grep -E "^\|?monitor\|${script_name}\|")
2011-08-31 09:34:43 +04:00
# Output looks like this:
2014-11-20 06:32:46 +03:00
# |monitor|60.nfs|1|ERROR|1314764004.030861|1314764004.035514|foo bar|
2011-08-31 09:34:43 +04:00
# This is the cheapest way of getting fields in the middle.
2014-11-20 06:32:46 +03:00
set -- $(IFS="|" ; echo $_out)
2011-08-31 09:34:43 +04:00
_code="$3"
_status="$4"
# The error output field can include colons so we'll try to
# preserve them. The weak checking at the beginning tries to make
2014-11-20 06:32:46 +03:00
# this work for both broken (no leading '|') and fixed output.
_out="${_out%|}"
_err_out="${_out#*monitor|${script_name}|*|*|*|*|}"
2011-08-31 09:34:43 +04:00
case "$_status" in
OK) : ;; # Do nothing special.
TIMEDOUT)
# Recast this as an error, since we can't exit with the
# correct negative number.
_code=1
_err_out="[Replay of TIMEDOUT scriptstatus - note incorrect return code.] ${_err_out}"
;;
DISABLED)
# Recast this as an OK, since we can't exit with the
# correct negative number.
_code=0
_err_out="[Replay of DISABLED scriptstatus - note incorrect return code.] ${_err_out}"
;;
*) : ;; # Must be ERROR, do nothing special.
esac
2013-06-24 13:03:26 +04:00
if [ -n "$_err_out" ] ; then
echo "$_err_out"
fi
2011-08-31 09:34:43 +04:00
exit $_code
2011-05-16 08:23:28 +04:00
}
2010-12-15 11:19:21 +03:00
ctdb_service_check_reconfigure ()
{
2013-04-29 21:45:21 +04:00
assert_service_name
2011-05-16 08:23:28 +04:00
# We only care about some events in this function. For others we
# return now.
2011-01-14 01:31:56 +03:00
case "$event_name" in
2011-05-16 08:23:28 +04:00
monitor|ipreallocated|reconfigure) : ;;
*) return 0 ;;
2011-01-14 01:31:56 +03:00
esac
2010-12-16 01:50:44 +03:00
2013-12-18 06:51:22 +04:00
if ctdb_reconfigure_take_lock ; then
2011-05-16 08:23:28 +04:00
# No events covered by this function are running, so proceed
# with gay abandon.
case "$event_name" in
reconfigure)
2013-04-29 20:59:41 +04:00
(ctdb_service_reconfigure)
2011-05-16 08:23:28 +04:00
exit $?
;;
ipreallocated)
2013-04-29 20:59:41 +04:00
if ctdb_service_needs_reconfigure ; then
ctdb_service_reconfigure
2011-05-16 08:23:28 +04:00
fi
;;
esac
2013-12-18 06:51:22 +04:00
ctdb_reconfigure_release_lock
2011-05-16 08:23:28 +04:00
else
# Somebody else is running an event we don't want to collide
# with. We proceed with caution.
case "$event_name" in
reconfigure)
# Tell whoever called us to retry.
exit 2
;;
ipreallocated)
# Defer any scheduled reconfigure and just run the
# rest of the ipreallocated event, as per the
# eventscript. There's an assumption here that the
# event doesn't depend on any scheduled reconfigure.
# This is true in the current code.
return 0
;;
monitor)
# There is most likely a reconfigure in progress so
# the service is possibly unstable. As above, we
# defer any scheduled reconfigured. We also replay
# the previous monitor status since that's the best
# information we have.
ctdb_replay_monitor_status
;;
esac
2009-11-13 10:28:25 +03:00
fi
}
2010-12-15 11:19:21 +03:00
##################################################################
# Does CTDB manage this service? - and associated auto-start/stop
2009-11-13 10:28:25 +03:00
ctdb_compat_managed_service ()
{
2013-04-29 21:13:36 +04:00
if [ "$1" = "yes" -a "$2" = "$service_name" ] ; then
2010-11-18 08:19:45 +03:00
CTDB_MANAGED_SERVICES="$CTDB_MANAGED_SERVICES $2"
2009-11-13 10:28:25 +03:00
fi
}
is_ctdb_managed_service ()
{
2013-04-29 21:45:21 +04:00
assert_service_name
2010-11-18 08:19:45 +03:00
# $t is used just for readability and to allow better accurate
# matching via leading/trailing spaces
2009-11-13 10:28:25 +03:00
t=" $CTDB_MANAGED_SERVICES "
2013-04-29 21:13:36 +04:00
# Return 0 if "<space>$service_name<space>" appears in $t
if [ "${t#* ${service_name} }" != "${t}" ] ; then
2010-11-18 08:19:45 +03:00
return 0
fi
# If above didn't match then update $CTDB_MANAGED_SERVICES for
# backward compatibility and try again.
2009-11-13 10:28:25 +03:00
ctdb_compat_managed_service "$CTDB_MANAGES_VSFTPD" "vsftpd"
ctdb_compat_managed_service "$CTDB_MANAGES_SAMBA" "samba"
2010-11-18 07:40:19 +03:00
ctdb_compat_managed_service "$CTDB_MANAGES_WINBIND" "winbind"
2011-07-26 01:35:49 +04:00
ctdb_compat_managed_service "$CTDB_MANAGES_HTTPD" "apache2"
2009-11-13 10:28:25 +03:00
ctdb_compat_managed_service "$CTDB_MANAGES_HTTPD" "httpd"
ctdb_compat_managed_service "$CTDB_MANAGES_ISCSI" "iscsi"
ctdb_compat_managed_service "$CTDB_MANAGES_CLAMD" "clamd"
2009-11-25 08:34:49 +03:00
ctdb_compat_managed_service "$CTDB_MANAGES_NFS" "nfs"
2010-12-06 03:26:43 +03:00
ctdb_compat_managed_service "$CTDB_MANAGES_NFS" "nfs-ganesha-gpfs"
2009-11-13 10:28:25 +03:00
2010-11-18 08:19:45 +03:00
t=" $CTDB_MANAGED_SERVICES "
2013-04-29 21:13:36 +04:00
# Return 0 if "<space>$service_name<space>" appears in $t
[ "${t#* ${service_name} }" != "${t}" ]
2009-11-13 10:28:25 +03:00
}
ctdb_start_stop_service ()
{
2013-04-29 21:45:21 +04:00
assert_service_name
2012-08-21 09:52:03 +04:00
# Allow service-start/service-stop pseudo-events to start/stop
# services when we're not auto-starting/stopping and we're not
# monitoring.
case "$event_name" in
service-start)
2013-04-29 21:13:36 +04:00
if is_ctdb_managed_service ; then
2012-08-21 09:52:03 +04:00
die 'service-start event not permitted when service is managed'
fi
if [ "$CTDB_SERVICE_AUTOSTARTSTOP" = "yes" ] ; then
die 'service-start event not permitted with $CTDB_SERVICE_AUTOSTARTSTOP = yes'
fi
2013-04-29 21:13:36 +04:00
ctdb_service_start
2012-08-21 09:52:03 +04:00
exit $?
;;
service-stop)
2013-04-29 21:13:36 +04:00
if is_ctdb_managed_service ; then
2012-08-21 09:52:03 +04:00
die 'service-stop event not permitted when service is managed'
fi
if [ "$CTDB_SERVICE_AUTOSTARTSTOP" = "yes" ] ; then
die 'service-stop event not permitted with $CTDB_SERVICE_AUTOSTARTSTOP = yes'
fi
2013-04-29 21:13:36 +04:00
ctdb_service_stop
2012-08-21 09:52:03 +04:00
exit $?
;;
esac
2011-08-08 07:13:59 +04:00
# Do nothing unless configured to...
[ "$CTDB_SERVICE_AUTOSTARTSTOP" = "yes" ] || return 0
2011-01-11 09:12:03 +03:00
[ "$event_name" = "monitor" ] || return 0
2013-04-29 21:13:36 +04:00
if is_ctdb_managed_service ; then
if ! is_ctdb_previously_managed_service ; then
echo "Starting service \"$service_name\" - now managed"
background_with_logging ctdb_service_start
2010-12-15 08:34:00 +03:00
exit $?
2009-11-13 10:28:25 +03:00
fi
2010-11-18 07:40:19 +03:00
else
2013-04-29 21:13:36 +04:00
if is_ctdb_previously_managed_service ; then
echo "Stopping service \"$service_name\" - no longer managed"
background_with_logging ctdb_service_stop
2010-12-15 08:34:00 +03:00
exit $?
2009-11-13 10:28:25 +03:00
fi
fi
}
ctdb_service_start ()
{
2010-12-15 08:34:00 +03:00
# The service is marked managed if we've ever tried to start it.
2013-04-29 21:18:01 +04:00
ctdb_service_managed
2010-12-15 08:34:00 +03:00
2013-04-29 21:18:01 +04:00
service_start || return $?
2011-08-11 03:39:25 +04:00
2013-04-29 21:18:01 +04:00
ctdb_counter_init
2011-08-05 10:39:57 +04:00
ctdb_check_tcp_init
2009-11-13 10:28:25 +03:00
}
ctdb_service_stop ()
{
2013-04-29 21:18:01 +04:00
ctdb_service_unmanaged
service_stop
2011-08-11 03:39:25 +04:00
}
# Default service_start() and service_stop() functions.
2014-02-14 09:59:08 +04:00
# These may be overridden in an eventscript.
2011-08-11 03:39:25 +04:00
service_start ()
{
2013-04-29 21:18:01 +04:00
service "$service_name" start
2011-08-11 03:39:25 +04:00
}
service_stop ()
{
2013-04-29 21:18:01 +04:00
service "$service_name" stop
2009-11-13 10:28:25 +03:00
}
2011-08-11 03:39:25 +04:00
##################################################################
2009-12-01 09:43:47 +03:00
ctdb_standard_event_handler ()
{
case "$1" in
status)
ctdb_checkstatus
exit
;;
setstatus)
2010-03-10 12:39:31 +03:00
shift
2009-12-01 09:43:47 +03:00
ctdb_setstatus "$@"
exit
;;
esac
}
2010-07-12 09:41:42 +04:00
# iptables doesn't like being re-entered, so flock-wrap it.
2014-11-21 06:39:43 +03:00
iptables ()
2010-07-12 09:41:42 +04:00
{
2011-06-28 09:04:58 +04:00
flock -w 30 $CTDB_VARDIR/iptables-ctdb.flock /sbin/iptables "$@"
2010-07-12 09:41:42 +04:00
}
2014-11-21 06:39:43 +03:00
ip6tables ()
{
flock -w 30 $CTDB_VARDIR/iptables-ctdb.flock /sbin/ip6tables "$@"
}
iptables_wrapper ()
{
_family="$1" ; shift
if [ "$_family" = "inet6" ] ; then
ip6tables "$@"
else
iptables "$@"
fi
}
2010-07-12 09:41:42 +04:00
2013-05-25 13:57:24 +04:00
# AIX (and perhaps others?) doesn't have mktemp
if ! which mktemp >/dev/null 2>&1 ; then
mktemp ()
{
_dir=false
if [ "$1" = "-d" ] ; then
_dir=true
shift
fi
_d="${TMPDIR:-/tmp}"
_hex10=$(dd if=/dev/urandom count=20 2>/dev/null | \
md5sum | \
sed -e 's@\(..........\).*@\1@')
_t="${_d}/tmp.${_hex10}"
(
umask 077
if $_dir ; then
mkdir "$_t"
else
>"$_t"
fi
)
echo "$_t"
}
fi
2010-08-26 08:59:59 +04:00
########################################################
# tickle handling
########################################################
update_tickles ()
{
_port="$1"
2013-04-17 07:26:04 +04:00
tickledir="$CTDB_VARDIR/state/tickles"
mkdir -p "$tickledir"
2010-08-26 08:59:59 +04:00
# Who am I?
_pnn=$(ctdb pnn) ; _pnn=${_pnn#PNN:}
# What public IPs do I hold?
2014-11-20 06:32:46 +03:00
_ips=$(ctdb -X ip | awk -F'|' -v pnn=$_pnn '$3 == pnn {print $2}')
2010-08-26 08:59:59 +04:00
# IPs as a regexp choice
_ipschoice="($(echo $_ips | sed -e 's/ /|/g' -e 's/\./\\\\./g'))"
# Record connections to our public IPs in a temporary file
_my_connections="${tickledir}/${_port}.connections"
rm -f "$_my_connections"
netstat -tn |
awk -v destpat="^${_ipschoice}:${_port}\$" \
'$1 == "tcp" && $6 == "ESTABLISHED" && $4 ~ destpat {print $5, $4}' |
sort >"$_my_connections"
# Record our current tickles in a temporary file
_my_tickles="${tickledir}/${_port}.tickles"
rm -f "$_my_tickles"
for _i in $_ips ; do
2014-11-20 06:32:46 +03:00
ctdb -X gettickles $_i $_port |
awk -F'|' 'NR > 1 { printf "%s:%s %s:%s\n", $2, $3, $4, $5 }'
2010-08-26 08:59:59 +04:00
done |
sort >"$_my_tickles"
# Add tickles for connections that we haven't already got tickles for
comm -23 "$_my_connections" "$_my_tickles" |
while read _src _dst ; do
ctdb addtickle $_src $_dst
done
# Remove tickles for connections that are no longer there
comm -13 "$_my_connections" "$_my_tickles" |
while read _src _dst ; do
ctdb deltickle $_src $_dst
done
rm -f "$_my_connections" "$_my_tickles"
}
2008-04-10 00:50:12 +04:00
########################################################
# load a site local config file
########################################################
2011-06-28 09:06:10 +04:00
[ -n "$CTDB_RC_LOCAL" -a -x "$CTDB_RC_LOCAL" ] && {
. "$CTDB_RC_LOCAL"
}
2008-04-10 01:01:22 +04:00
[ -x $CTDB_BASE/rc.local ] && {
2008-04-10 00:50:12 +04:00
. $CTDB_BASE/rc.local
}
2008-08-20 03:47:00 +04:00
2009-10-19 09:22:15 +04:00
[ -d $CTDB_BASE/rc.local.d ] && {
for i in $CTDB_BASE/rc.local.d/* ; do
[ -x "$i" ] && . "$i"
done
}
2009-12-01 09:43:47 +03:00
script_name="${0##*/}" # basename
2009-11-19 08:48:19 +03:00
service_fail_limit=1
2011-01-11 09:12:03 +03:00
event_name="$1"